package com.hai.dao;

import com.hai.entity.CmsContent;
import com.hai.entity.CmsContentExample.Criteria;
import com.hai.entity.CmsContentExample.Criterion;
import com.hai.entity.CmsContentExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class CmsContentSqlProvider {

    public String countByExample(CmsContentExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("cms_content");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(CmsContentExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("cms_content");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(CmsContent record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("cms_content");
        
        if (record.getCategoryId() != null) {
            sql.VALUES("category_id", "#{categoryId,jdbcType=BIGINT}");
        }
        
        if (record.getCategoryCode() != null) {
            sql.VALUES("category_code", "#{categoryCode,jdbcType=VARCHAR}");
        }
        
        if (record.getTitle() != null) {
            sql.VALUES("title", "#{title,jdbcType=VARCHAR}");
        }
        
        if (record.getDescription() != null) {
            sql.VALUES("description", "#{description,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getHasPatch() != null) {
            sql.VALUES("has_patch", "#{hasPatch,jdbcType=INTEGER}");
        }
        
        if (record.getVisitCount() != null) {
            sql.VALUES("visit_count", "#{visitCount,jdbcType=INTEGER}");
        }
        
        if (record.getTag() != null) {
            sql.VALUES("tag", "#{tag,jdbcType=VARCHAR}");
        }
        
        if (record.getImgData() != null) {
            sql.VALUES("img_data", "#{imgData,jdbcType=VARCHAR}");
        }
        
        if (record.getJumpType() != null) {
            sql.VALUES("jump_type", "#{jumpType,jdbcType=INTEGER}");
        }
        
        if (record.getJumpName() != null) {
            sql.VALUES("jump_name", "#{jumpName,jdbcType=VARCHAR}");
        }
        
        if (record.getJumpUrl() != null) {
            sql.VALUES("jump_url", "#{jumpUrl,jdbcType=VARCHAR}");
        }
        
        if (record.getSortId() != null) {
            sql.VALUES("sort_id", "#{sortId,jdbcType=INTEGER}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRecommend() != null) {
            sql.VALUES("recommend", "#{recommend,jdbcType=BIT}");
        }
        
        if (record.getCompanyId() != null) {
            sql.VALUES("company_id", "#{companyId,jdbcType=BIGINT}");
        }
        
        if (record.getCompanyName() != null) {
            sql.VALUES("company_name", "#{companyName,jdbcType=VARCHAR}");
        }
        
        if (record.getUserName() != null) {
            sql.VALUES("user_name", "#{userName,jdbcType=VARCHAR}");
        }
        
        if (record.getOpId() != null) {
            sql.VALUES("op_id", "#{opId,jdbcType=BIGINT}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getContent() != null) {
            sql.VALUES("content", "#{content,jdbcType=LONGVARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExampleWithBLOBs(CmsContentExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("category_id");
        sql.SELECT("category_code");
        sql.SELECT("title");
        sql.SELECT("description");
        sql.SELECT("create_time");
        sql.SELECT("`status`");
        sql.SELECT("has_patch");
        sql.SELECT("visit_count");
        sql.SELECT("tag");
        sql.SELECT("img_data");
        sql.SELECT("jump_type");
        sql.SELECT("jump_name");
        sql.SELECT("jump_url");
        sql.SELECT("sort_id");
        sql.SELECT("update_time");
        sql.SELECT("recommend");
        sql.SELECT("company_id");
        sql.SELECT("company_name");
        sql.SELECT("user_name");
        sql.SELECT("op_id");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.SELECT("content");
        sql.FROM("cms_content");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String selectByExample(CmsContentExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("category_id");
        sql.SELECT("category_code");
        sql.SELECT("title");
        sql.SELECT("description");
        sql.SELECT("create_time");
        sql.SELECT("`status`");
        sql.SELECT("has_patch");
        sql.SELECT("visit_count");
        sql.SELECT("tag");
        sql.SELECT("img_data");
        sql.SELECT("jump_type");
        sql.SELECT("jump_name");
        sql.SELECT("jump_url");
        sql.SELECT("sort_id");
        sql.SELECT("update_time");
        sql.SELECT("recommend");
        sql.SELECT("company_id");
        sql.SELECT("company_name");
        sql.SELECT("user_name");
        sql.SELECT("op_id");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("cms_content");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        CmsContent record = (CmsContent) parameter.get("record");
        CmsContentExample example = (CmsContentExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("cms_content");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getCategoryId() != null) {
            sql.SET("category_id = #{record.categoryId,jdbcType=BIGINT}");
        }
        
        if (record.getCategoryCode() != null) {
            sql.SET("category_code = #{record.categoryCode,jdbcType=VARCHAR}");
        }
        
        if (record.getTitle() != null) {
            sql.SET("title = #{record.title,jdbcType=VARCHAR}");
        }
        
        if (record.getDescription() != null) {
            sql.SET("description = #{record.description,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getHasPatch() != null) {
            sql.SET("has_patch = #{record.hasPatch,jdbcType=INTEGER}");
        }
        
        if (record.getVisitCount() != null) {
            sql.SET("visit_count = #{record.visitCount,jdbcType=INTEGER}");
        }
        
        if (record.getTag() != null) {
            sql.SET("tag = #{record.tag,jdbcType=VARCHAR}");
        }
        
        if (record.getImgData() != null) {
            sql.SET("img_data = #{record.imgData,jdbcType=VARCHAR}");
        }
        
        if (record.getJumpType() != null) {
            sql.SET("jump_type = #{record.jumpType,jdbcType=INTEGER}");
        }
        
        if (record.getJumpName() != null) {
            sql.SET("jump_name = #{record.jumpName,jdbcType=VARCHAR}");
        }
        
        if (record.getJumpUrl() != null) {
            sql.SET("jump_url = #{record.jumpUrl,jdbcType=VARCHAR}");
        }
        
        if (record.getSortId() != null) {
            sql.SET("sort_id = #{record.sortId,jdbcType=INTEGER}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRecommend() != null) {
            sql.SET("recommend = #{record.recommend,jdbcType=BIT}");
        }
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        }
        
        if (record.getCompanyName() != null) {
            sql.SET("company_name = #{record.companyName,jdbcType=VARCHAR}");
        }
        
        if (record.getUserName() != null) {
            sql.SET("user_name = #{record.userName,jdbcType=VARCHAR}");
        }
        
        if (record.getOpId() != null) {
            sql.SET("op_id = #{record.opId,jdbcType=BIGINT}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getContent() != null) {
            sql.SET("content = #{record.content,jdbcType=LONGVARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExampleWithBLOBs(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("cms_content");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("category_id = #{record.categoryId,jdbcType=BIGINT}");
        sql.SET("category_code = #{record.categoryCode,jdbcType=VARCHAR}");
        sql.SET("title = #{record.title,jdbcType=VARCHAR}");
        sql.SET("description = #{record.description,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("has_patch = #{record.hasPatch,jdbcType=INTEGER}");
        sql.SET("visit_count = #{record.visitCount,jdbcType=INTEGER}");
        sql.SET("tag = #{record.tag,jdbcType=VARCHAR}");
        sql.SET("img_data = #{record.imgData,jdbcType=VARCHAR}");
        sql.SET("jump_type = #{record.jumpType,jdbcType=INTEGER}");
        sql.SET("jump_name = #{record.jumpName,jdbcType=VARCHAR}");
        sql.SET("jump_url = #{record.jumpUrl,jdbcType=VARCHAR}");
        sql.SET("sort_id = #{record.sortId,jdbcType=INTEGER}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("recommend = #{record.recommend,jdbcType=BIT}");
        sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        sql.SET("company_name = #{record.companyName,jdbcType=VARCHAR}");
        sql.SET("user_name = #{record.userName,jdbcType=VARCHAR}");
        sql.SET("op_id = #{record.opId,jdbcType=BIGINT}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        sql.SET("content = #{record.content,jdbcType=LONGVARCHAR}");
        
        CmsContentExample example = (CmsContentExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("cms_content");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("category_id = #{record.categoryId,jdbcType=BIGINT}");
        sql.SET("category_code = #{record.categoryCode,jdbcType=VARCHAR}");
        sql.SET("title = #{record.title,jdbcType=VARCHAR}");
        sql.SET("description = #{record.description,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("has_patch = #{record.hasPatch,jdbcType=INTEGER}");
        sql.SET("visit_count = #{record.visitCount,jdbcType=INTEGER}");
        sql.SET("tag = #{record.tag,jdbcType=VARCHAR}");
        sql.SET("img_data = #{record.imgData,jdbcType=VARCHAR}");
        sql.SET("jump_type = #{record.jumpType,jdbcType=INTEGER}");
        sql.SET("jump_name = #{record.jumpName,jdbcType=VARCHAR}");
        sql.SET("jump_url = #{record.jumpUrl,jdbcType=VARCHAR}");
        sql.SET("sort_id = #{record.sortId,jdbcType=INTEGER}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("recommend = #{record.recommend,jdbcType=BIT}");
        sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        sql.SET("company_name = #{record.companyName,jdbcType=VARCHAR}");
        sql.SET("user_name = #{record.userName,jdbcType=VARCHAR}");
        sql.SET("op_id = #{record.opId,jdbcType=BIGINT}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        CmsContentExample example = (CmsContentExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(CmsContent record) {
        SQL sql = new SQL();
        sql.UPDATE("cms_content");
        
        if (record.getCategoryId() != null) {
            sql.SET("category_id = #{categoryId,jdbcType=BIGINT}");
        }
        
        if (record.getCategoryCode() != null) {
            sql.SET("category_code = #{categoryCode,jdbcType=VARCHAR}");
        }
        
        if (record.getTitle() != null) {
            sql.SET("title = #{title,jdbcType=VARCHAR}");
        }
        
        if (record.getDescription() != null) {
            sql.SET("description = #{description,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getHasPatch() != null) {
            sql.SET("has_patch = #{hasPatch,jdbcType=INTEGER}");
        }
        
        if (record.getVisitCount() != null) {
            sql.SET("visit_count = #{visitCount,jdbcType=INTEGER}");
        }
        
        if (record.getTag() != null) {
            sql.SET("tag = #{tag,jdbcType=VARCHAR}");
        }
        
        if (record.getImgData() != null) {
            sql.SET("img_data = #{imgData,jdbcType=VARCHAR}");
        }
        
        if (record.getJumpType() != null) {
            sql.SET("jump_type = #{jumpType,jdbcType=INTEGER}");
        }
        
        if (record.getJumpName() != null) {
            sql.SET("jump_name = #{jumpName,jdbcType=VARCHAR}");
        }
        
        if (record.getJumpUrl() != null) {
            sql.SET("jump_url = #{jumpUrl,jdbcType=VARCHAR}");
        }
        
        if (record.getSortId() != null) {
            sql.SET("sort_id = #{sortId,jdbcType=INTEGER}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRecommend() != null) {
            sql.SET("recommend = #{recommend,jdbcType=BIT}");
        }
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{companyId,jdbcType=BIGINT}");
        }
        
        if (record.getCompanyName() != null) {
            sql.SET("company_name = #{companyName,jdbcType=VARCHAR}");
        }
        
        if (record.getUserName() != null) {
            sql.SET("user_name = #{userName,jdbcType=VARCHAR}");
        }
        
        if (record.getOpId() != null) {
            sql.SET("op_id = #{opId,jdbcType=BIGINT}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getContent() != null) {
            sql.SET("content = #{content,jdbcType=LONGVARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, CmsContentExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}